您的位置:首页 > 其它

HDU 3315 My Brute(二分图最优匹配)

2016-02-16 20:24 302 查看
题意:有S1到Sn这n个勇士要和X1到Xn这n个勇士决斗,初始时,Si的决斗对象是Xi. 如果Si赢了Xi,那么你将获得Vi分,否则你将获得-Vi分. Si和Xi对决时,Si有初始生命Hi,初始攻击Ai, Xi有初始生命Pi,初始攻击Bi. 且Si先出手,然后Xi失去Ai生命,之后如果Xi没死,那么Xi出手,Si失去Bi生命. 直到有一方的生命值<=0时,决斗结束.

现在要你重新安排S和X的决斗顺序,使得你能获得的分最多.如果有多个最优解,你要选取那个维持初始决斗顺序最多的解.

思路:之前用网络流做,现在用二分图最优匹配来做,快了不少

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn=100+5;

struct Max_Match
{
int n;
int W[maxn][maxn],Lx[maxn],Ly[maxn];
bool S[maxn],T[maxn];
int left[maxn];

bool match(int i)
{
S[i]=true;
for(int j=1;j<=n;j++)if(Lx[i]+Ly[j]==W[i][j] && !T[j])
{
T[j]=true;
if(left[j]==-1 || match(left[j]))
{
left[j]=i;
return true;
}
}
return false;
}

void update()
{
int a=1<<30;
for(int i=1;i<=n;i++)if(S[i])
for(int j=1;j<=n;j++)if(!T[j])
a=min(a, Lx[i]+Ly[j]-W[i][j]);
for(int i=1;i<=n;i++)
{
if(S[i]) Lx[i] -=a;
if(T[i]) Ly[i] +=a;
}
}

int solve(int n)
{
this->n=n;
memset(left,-1,sizeof(left));
for(int i=1;i<=n;i++)
{
Lx[i]=Ly[i]=0;
for(int j=1;j<=n;j++)
Lx[i]=max(Lx[i], W[i][j]);
}

for(int i=1;i<=n;i++)
{
while(true)
{
memset(S,0,sizeof(S));
memset(T,0,sizeof(T));
if(match(i)) break;
else update();
}
}
int ans=0;
for(int i=1;i<=n;i++) ans+=W[left[i]][i];
return ans;
}
}KM;

int n;
int v[maxn],h[maxn],p[maxn],a[maxn],b[maxn];//遵循题意
int W[maxn][maxn];
int ack(int i,int j)//返回左i与右j的输赢比分
{
int hpi=h[i],hpj=p[j];//两者血量
int vi=a[i],vj=b[j];//两者攻击
while(hpi && hpj)
{
hpj-=vi;
if(hpj<=0) return v[i];
hpi-=vj;
if(hpi<=0) return -v[i];
}
}

int main()
{
while(scanf("%d",&n)==1 && n)
{
for(int i=1;i<=n;i++) scanf("%d",&v[i]);
for(int i=1;i<=n;i++) scanf("%d",&h[i]);
for(int i=1;i<=n;i++) scanf("%d",&p[i]);
for(int i=1;i<=n;i++) scanf("%d",&a[i]);
for(int i=1;i<=n;i++) scanf("%d",&b[i]);

for(int i=1;i<=n;i++)
for(int j=1;j<=n;j++)
W[i][j]=ack(i,j);

for(int i=1;i<=n;i++)
for(int j=1;j<=n;j++)
{
KM.W[i][j]=W[i][j]*(n+1);
if(i==j) ++KM.W[i][j];
}

int ans=KM.solve(n);
int v1=ans/(n+1);//最优匹配权值和
int v2=ans%(n+1);//最优匹配用到的老边数
if(v1<=0) printf("Oh, I lose my dear seaco!\n");
else printf("%d %.3lf%%\n",v1,100.0*v2/n);
}
return 0;
}


Description

Seaco is a beautiful girl and likes play a game called “My Brute”. Before Valentine’s Day, starvae and xingxing ask seaco if she wants to spend the Valentine’s Day with them, but seaco only can spend it with one of them. It’s hard
to choose from the two excellent boys. So there will be a competition between starvae and xingxing. The competition is like the game “My Brute”.



Now starvae have n brutes named from S1 to Sn and xingxing’s brutes are named from X1 to Xn. A competition consists of n games. At the beginning, starvae's brute Si must versus xingxing’s brute Xi. But it’s hard for starvae to win the competition, so starvae
can change his brutes’ order to win more games. For the starvae’s brute Si, if it wins the game, starvae can get Vi scores, but if it loses the game, starvae will lose Vi scores. Before the competition, starvae’s score is 0. Each brute can only play one game.
After n games, if starvae’s score is larger than 0, we say starvae win the competition, otherwise starvae lose it.

It’s your time to help starvae change the brutes’ order to make starvae’s final score be the largest. If there are multiple orders, you should choose the one whose order changes the least from the original one. The original order is S1, S2, S3 … Sn-1, Sn, while
the final order is up to you.

For starvae’s brute Si (maybe this brute is not the original brute Si, it is the ith brute after you ordered them) and xingxing’s brute Xi, at first Si has Hi HP and Xi has Pi HP, Si’s damage is Ai and Xi’s is Bi, in other words, if Si attacks, Xi will lose
Ai HP and if Xi attacks, Si will lose Bi HP, Si attacks first, then it’s Xi’s turn, then Si… until one of them’s HP is less than 0 or equal to 0, that, it lose the game, and the other win the game.

Come on, starvae’s happiness is in your hand!

Input

First line is a number n. (1<=n<=90) Then follows a line with n numbers mean V1 to Vn. (0<Vi<1000) Then follows a line with n numbers mean H1 to Hn. (1<=Hi<=100)Then follows a line with n numbers mean P1 to Pn. (1<=Pi<=100) Then follows
a line with n numbers mean A1 to An.(1<=Ai<=50) Then follows a line with n numbers mean B1 to Bn. (1<=Bi<=50) A zero signals the end of input and this test case is not to be processed.

Output

For each test case, if starvae can win the competition, print the largest score starvae can get, and then follow a real percentage means the similarity between the original order and the final order you had changed, round it to three
digits after the decimal point. If starvae can’t win the competition after changing the order, please just print “Oh, I lose my dear seaco!” Maybe the sample can help you get it.

Sample Input

3
4 5 6
6 8 10
12 14 16
7 7 6
7 3 5
3
4 5 6
6 8 10
12 14 16
5 5 5
5 5 5
0


Sample Output

7 33.333%
Oh, I lose my dear seaco!
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: